import { defineComponent, props, setup, $prefix, $props, $setup } from '@opentinyvue/vue-common';
import { renderless, api } from '@opentinyvue/vue-renderless/steps/vue';
import { IconFinish, IconWarn, IconChevronLeft, IconChevronRight } from '@opentinyvue/vue-icon';
import Popover from '@opentinyvue/vue-popover';
import { renderless as renderless$1, api as api$1 } from '@opentinyvue/vue-renderless/steps/slide-bar';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var classes$1 = {
  "steps-icon": "flex-none flex items-center justify-center rounded-full border-0.5 border-current text-color-icon-tertiary bg-color-bg-3",
  "steps-icon-left": "w-full h-full flex items-center justify-center rounded-full border-0.5 border-color-brand text-color-brand bg-color-bg-1 relative z-10",
  "steps-icon-right": "w-full h-full flex items-center justify-center rounded-full border-0.5 border-color-brand text-color-brand bg-color-bg-1 relative z-[9999]",
  "icon-mini": "w-2 h-2 text-xs",
  "icon-small": "w-4 h-4 text-xs",
  "icon-medium": "w-6 h-6 text-sm",
  "icon-large": "w-8 h-8 text-base",
  "icon-error": "text-color-error bg-color-bg-1",
  "icon-doing": "text-color-brand bg-color-info-primary-subtler",
  "icon-done": "text-color-brand bg-color-info-primary-subtler",
  "icon-disabled": "bg-color-bg-3 text-color-border",
  "icon-error-active": "bg-color-error-subtler border-color-error",
  "icon-doing-active": "bg-color-brand border-color-brand text-color-text-inverse",
  "icon-done-active": "bg-color-brand border-color-brand text-color-text-inverse",
  "icon-disabled-active": "bg-color-bg-3 text-color-border",
  "steps-line": "border-t-0.5 sm:border-t border-color-text flex-auto",
  "left-line-mini": "mr-1",
  "left-line-small": "mr-2",
  "left-line-medium": "mr-2",
  "left-line-large": "mr-3",
  "right-line-mini": "ml-1",
  "right-line-small": "ml-2",
  "right-line-medium": "ml-2",
  "right-line-large": "ml-3",
  "steps-title": "hidden sm:block text-sm ml-2 font-medium truncate leading-5.5",
  "title-font-mini": "text-xs",
  "title-font-small": "text-xs",
  "title-font-medium": "text-sm",
  "title-font-large": "text-base",
  "circle-wrap": "flex-none flex relative z-10",
  "icon-circle": "flex-none rounded-full border-0.5 border-color-brand bg-color-bg-1 font-medium absolute"
};
var __vue2_script$3 = defineComponent({
  emits: ["click"],
  components: {
    IconFinish: IconFinish(),
    IconWarn: IconWarn()
  },
  props: [].concat(props, ["vertical", "nameField", "statusField", "data", "active", "visibleNum", "descriptionField", "size"]),
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      classes: classes$1
    });
  }
});
var render$2 = function render$22() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "flex text-color-text-primary",
    attrs: {
      "data-tag": "tiny-steps"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.startIndex !== 0,
      expression: "state.startIndex !== 0"
    }],
    class: ["flex-1 flex flex-col cursor-pointer", _vm.vertical ? "text-center" : "sm:max-w-[theme(spacing.80)] sm:mr-4"],
    attrs: {
      "data-tag": "tiny-steps-left"
    },
    on: {
      "click": function click($event) {
        _vm.state.startIndex--;
      }
    }
  }, [_c("div", {
    staticClass: "flex items-center relative",
    attrs: {
      "data-tag": "tiny-steps-main"
    }
  }, [_c("div", {
    class: ["border-t-0.5 sm:border-t  flex-auto opacity-0", {
      "sm:min-w-[theme(spacing.6)] sm:ml-4 sm:hidden": !_vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps-line"
    }
  }), _c("div", {
    class: [_vm.gcls("circle-wrap"), _vm.gcls("icon-" + _vm.size)],
    attrs: {
      "data-tag": "tiny-steps-icon"
    }
  }, [_c("div", {
    class: _vm.gcls("steps-icon-left")
  }, [_vm._v(" " + _vm._s(_vm.size === "mini" ? "" : _vm.state.startIndex) + " ")]), _vm.state.startIndex - 1 > 0 ? _vm._l(_vm.state.startIndex - 1, function(item, index) {
    return _c("div", {
      key: index,
      class: [_vm.gcls("icon-circle"), _vm.gcls("icon-" + _vm.size)],
      style: {
        right: (_vm.state.startIndex - 1 - index) * 4 + "px"
      }
    });
  }) : _vm._e()], 2), _c("div", {
    class: ["border-t-0.5 sm:border-t flex-auto", {
      "sm:min-w-[theme(spacing.6)] sm:ml-4": !_vm.vertical
    }, {
      "border-color-brand": _vm.data[_vm.state.startIndex - 1] && _vm.data[_vm.state.startIndex - 1].status === "done"
    }],
    attrs: {
      "data-tag": "tiny-steps-line"
    }
  })])]), _vm._l(_vm.data, function(node, index) {
    return _c("div", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: _vm.isVisibleHandler(index) === "visible",
        expression: "isVisibleHandler(index) === 'visible'"
      }],
      key: index,
      class: _vm.m("group flex-1 flex flex-col cursor-pointer text-center", {
        "text-color-brand": index === _vm.active
      }, _vm.vertical ? "" : "sm:min-w-[theme(spacing.32)] sm:max-w-[theme(spacing.80)] sm:mr-4 sm:text-left", {
        "flex-none": index === _vm.data.length - 1 && !_vm.vertical
      }, {
        " hover:text-color-brand-hover active:text-color-brand-active": node[_vm.statusField] !== "disabled" && node[_vm.statusField] !== "error"
      }, {
        "text-color-text-disabled": node[_vm.statusField] === "disabled"
      }, {
        "text-color-error": node[_vm.statusField] === "error"
      }),
      attrs: {
        "data-tag": "tiny-steps-block"
      },
      on: {
        "click": function click($event) {
          return _vm.$emit("click", index, node, $event);
        }
      }
    }, [_c("div", {
      staticClass: "flex items-center",
      attrs: {
        "data-tag": "tiny-steps-main"
      }
    }, [_c("div", {
      class: _vm.m(_vm.gcls("steps-line"), _vm.gcls("left-line-" + _vm.size), {
        "opacity-0": index === 0 && _vm.state.startIndex === 0
      }, {
        "sm:hidden sm:min-w-[theme(spacing.6)] sm:ml-4": !_vm.vertical
      }, {
        "border-color-brand": ["done", "doing"].includes(node[_vm.statusField])
      }),
      attrs: {
        "data-tag": "tiny-steps-line"
      }
    }), _c("div", {
      class: _vm.m(_vm.gcls("steps-icon"), _vm.gcls("icon-" + _vm.size), {
        "bg-color-icon-tertiary border-color-icon-tertiary text-color-text-inverse": index === _vm.active
      }, _vm.gcls("icon-" + node[_vm.statusField]), index === _vm.active && _vm.gcls("icon-" + node[_vm.statusField] + "-active"), {
        "bg-color-error border-color-error": index === _vm.active && _vm.size === "mini" && node[_vm.statusField] === "error"
      }),
      attrs: {
        "data-tag": "tiny-steps-icon"
      }
    }, [_vm.size !== "mini" ? [node[_vm.statusField] === "done" ? [_c("icon-finish", {
      class: index === _vm.active ? "fill-color-icon-inverse" : "fill-color-brand",
      attrs: {
        "custom-class": _vm.m("w-3.5 h-3.5", {
          "w-2.5 h-2.5": _vm.size === "small"
        }, {
          "w-4.5 h-4.5": _vm.size === "large"
        })
      }
    })] : node[_vm.statusField] === "error" ? [_c("icon-warn", {
      attrs: {
        "custom-class": _vm.m("w-3.5 h-3.5 fill-color-error", {
          "w-2.5 h-2.5": _vm.size === "small"
        }, {
          "w-4.5 h-4.5": _vm.size === "large"
        })
      }
    })] : [_vm._v(" " + _vm._s(index + 1) + " ")]] : _vm._e()], 2), !_vm.vertical ? _c("div", {
      class: [_vm.gcls("steps-title"), _vm.gcls("title-font-" + _vm.size)],
      attrs: {
        "data-tag": "tiny-steps-title",
        "title": node[_vm.nameField]
      }
    }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]) : _vm._e(), _c("div", {
      class: _vm.m(_vm.gcls("steps-line"), _vm.gcls("right-line-" + _vm.size), {
        "sm:hidden": !_vm.vertical && index === _vm.data.length - 1
      }, {
        "opacity-0": index === _vm.data.length - 1
      }, {
        "sm:min-w-[theme(spacing.6)] sm:ml-4": !_vm.vertical
      }, {
        "border-color-brand": node[_vm.statusField] === "done"
      }),
      attrs: {
        "data-tag": "tiny-steps-line"
      }
    })]), _vm._t("item", function() {
      return [_c("div", {
        class: ["mt-3 font-medium truncate mx-5 ", _vm.gcls("title-font-" + _vm.size), {
          "sm:hidden sm:mx-0": !_vm.vertical
        }],
        attrs: {
          "data-tag": "tiny-steps-title",
          "title": node[_vm.nameField]
        }
      }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]), node[_vm.descriptionField] ? _c("div", {
        class: _vm.m("text-xs text-color-text-secondary mt-0.5 line-clamp-2 mx-5 break-all leading-5", {
          "text-color-text-disabled": node[_vm.statusField] === "disabled"
        }, {
          "text-color-brand": index === _vm.active
        }, {
          "text-color-error": node[_vm.statusField] === "error" && index === _vm.active
        }, !_vm.vertical ? "sm:ml-8" : ""),
        attrs: {
          "data-tag": "tiny-steps-description"
        }
      }, [_vm._v(" " + _vm._s(node[_vm.descriptionField]) + " ")]) : _vm._e()];
    }, {
      "slotScope": node,
      "index": index
    })], 2);
  }), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.startIndex + _vm.visibleNum < _vm.data.length,
      expression: "state.startIndex + visibleNum < data.length"
    }],
    class: ["flex-1 flex flex-col cursor-pointer text-center", {
      "sm:min-w-[theme(spacing.32)] sm:max-w-[theme(spacing.80)] sm:text-left": !_vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps-right"
    },
    on: {
      "click": function click($event) {
        _vm.state.startIndex++;
      }
    }
  }, [_c("div", {
    staticClass: "flex items-center relative",
    attrs: {
      "data-tag": "tiny-steps-main"
    }
  }, [_c("div", {
    class: ["border-t-0.5 sm:border-t  flex-auto", {
      "sm:hidden sm:min-w-[theme(spacing.6)] sm:ml-4": !_vm.vertical
    }, {
      "border-color-brand": _vm.data[_vm.state.endIndex] && ["done", "doing"].includes(_vm.data[_vm.state.endIndex].status)
    }],
    attrs: {
      "data-tag": "tiny-steps-line"
    }
  }), _c("div", {
    class: [_vm.gcls("circle-wrap"), _vm.gcls("icon-" + _vm.size)],
    attrs: {
      "data-tag": "tiny-steps-icon"
    }
  }, [_c("div", {
    class: _vm.gcls("steps-icon-right")
  }, [_vm._v(" " + _vm._s(_vm.size === "mini" ? "" : _vm.state.endIndex + 1) + " ")]), _vm.state.rightNodePositions.length > 0 ? _vm._l(_vm.state.rightNodePositions, function(item, index) {
    return _c("div", {
      key: index,
      class: [_vm.gcls("icon-circle"), _vm.gcls("icon-" + _vm.size)],
      style: item
    });
  }) : _vm._e()], 2), _c("div", {
    class: ["border-t-0.5 sm:border-t  flex-auto opacity-0", {
      "sm:hidden sm:min-w-[theme(spacing.6)] sm:ml-4": !_vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps-line"
    }
  })])])], 2);
};
var staticRenderFns$2 = [];
var __cssModules$3 = {};
var __component__$3 = /* @__PURE__ */ normalizeComponent(__vue2_script$3, render$2, staticRenderFns$2, false, __vue2_injectStyles$3);
function __vue2_injectStyles$3(context) {
  for (var o in __cssModules$3) {
    this[o] = __cssModules$3[o];
  }
}
var MobileFirstTemplate = /* @__PURE__ */ function() {
  return __component__$3.exports;
}();
var mode = {
  tiny_mode: "mobile-first"
};
var __vue2_script$2 = defineComponent({
  emits: ["click"],
  components: {
    IconChevronLeft: IconChevronLeft(mode),
    IconChevronRight: IconChevronRight(mode)
  },
  props: _extends({}, $props, {
    data: Array,
    duration: {
      type: Number,
      default: 300
    },
    delay: {
      type: Number,
      default: 5
    },
    noArrow: Boolean,
    flex: Boolean,
    size: String
  }),
  setup: function setup2(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$1,
      api: api$1
    });
  }
});
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "w-full flex",
    attrs: {
      "data-tag": "tiny-steps-slide-bar"
    }
  }, [_c("div", {
    ref: "leftButton",
    class: ["hidden flex-none cursor-pointer items-center select-none", {
      "sm:flex": _vm.slideBarState.canLeftScroll || _vm.slideBarState.canRightScroll
    }, _vm.size === "large" ? "h-12" : "h-8"],
    attrs: {
      "data-tag": "left-button"
    },
    on: {
      "click": _vm.leftSlideHandler
    }
  }, [_vm._t("left-button", function() {
    return [_c("div", {
      staticClass: "w-4 h-full flex items-center justify-center mr-1.5 bg-color-bg-2"
    }, [_c("IconChevronLeft", {
      staticClass: "h-3 w-3"
    })], 1)];
  }, {
    "show": _vm.slideBarState.canLeftScroll,
    "index": _vm.slideBarState.boundingIndex.left
  })], 2), _c("div", {
    ref: "slideMain",
    staticClass: "flex-auto overflow-auto scrollbar-size-0",
    attrs: {
      "data-tag": "slide-main"
    }
  }, [_c("div", {
    staticClass: "flex"
  }, _vm._l(_vm.data, function(node, index) {
    return _c("div", {
      key: index,
      ref: "block" + index,
      refInFor: true,
      style: {
        width: _vm.flex ? 100 / _vm.data.length + "%" : null
      }
    }, [_vm._t("block", function() {
      return [_vm._v(_vm._s(index))];
    }, {
      "slotScoped": {
        node,
        index,
        show: index > _vm.slideBarState.boundingIndex.left && (_vm.slideBarState.boundingIndex.right === -1 || index < _vm.slideBarState.boundingIndex.right)
      }
    }), _vm._t("block-bottom", null, {
      "node": node,
      "index": index
    })], 2);
  }), 0)]), _c("div", {
    ref: "rightButton",
    class: ["hidden flex-none cursor-pointer items-center select-none", {
      "sm:flex": _vm.slideBarState.canLeftScroll || _vm.slideBarState.canRightScroll
    }, _vm.size === "large" ? "h-12" : "h-8"],
    attrs: {
      "data-tag": "right-button"
    },
    on: {
      "click": _vm.rightSlideHandler
    }
  }, [_vm._t("right-button", function() {
    return [_c("div", {
      staticClass: "w-4 h-full flex items-center justify-center ml-1.5 bg-color-bg-2"
    }, [_c("IconChevronRight", {
      staticClass: "h-3 w-3"
    })], 1)];
  }, {
    "show": _vm.slideBarState.canRightScroll,
    "index": _vm.slideBarState.boundingIndex.right
  })], 2)]);
};
var staticRenderFns$1 = [];
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$1, staticRenderFns$1, false, __vue2_injectStyles$2);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var SlideBar = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var classes = {
  "steps-advanced": "w-full flex text-color-text text-xs leading-4",
  "steps-block": "flex rounded-sm relative cursor-pointer group text-color-text-primary bg-color-bg-2 hover:bg-color-border-separator",
  "steps-block-error": "text-color-error bg-color-error-subtler hover:bg-error-disabled",
  "steps-block-disabled": "text-color-text-disabled hover:bg-color-bg-2",
  "steps-block-done": "bg-color-info-primary-subtler hover:bg-color-info-secondary-disabled",
  "steps-block-doing": "bg-color-info-primary-subtler hover:bg-color-brand-hover",
  "steps-block-error-active": "bg-color-error hover:bg-color-error",
  "steps-block-disabled-active": "bg-color-bg-2 hover:bg-color-bg-2",
  "steps-block-done-active": "bg-color-brand hover:bg-color-brand",
  "steps-block-doing-active": "bg-color-brand hover:bg-color-brand",
  "steps-text": "group flex-auto max-w-full truncate text-color-text-secondary",
  "steps-text-error": "text-color-text-primary",
  "steps-text-disabled": "text-color-border",
  "steps-text-done": "text-color-text-primary",
  "steps-text-doing": "group-hover:text-color-text-inverse text-color-text-primary",
  "steps-content": "flex-auto flex max-w-full items-center justify-center px-4 overflow-hidden h-full"
};
var __vue2_script$1 = defineComponent({
  emits: ["click"],
  components: {
    TinyPopover: Popover,
    SlideBar,
    IconFinish: IconFinish(),
    IconWarn: IconWarn(),
    IconChevronLeft: IconChevronLeft(),
    IconChevronRight: IconChevronRight()
  },
  props: [].concat(props, ["vertical", "nameField", "statusField", "descriptionField", "data", "active", "visibleNum", "duration", "noArrow", "flex", "size"]),
  setup: function setup3(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api,
      classes
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: _vm.gcls("steps-advanced"),
    attrs: {
      "data-tag": "tiny-steps-advanced"
    }
  }, [_c("SlideBar", {
    ref: "slideBar",
    attrs: {
      "data": _vm.data,
      "duration": _vm.duration,
      "no-arrow": _vm.noArrow,
      "flex": _vm.flex,
      "size": _vm.size
    },
    scopedSlots: _vm._u([{
      key: "left-button",
      fn: function fn(slotScoped) {
        return [_c("div", {
          class: ["w-4 h-full flex items-center justify-center mr-1.5", slotScoped.show ? "bg-color-bg-2 text-color-text hover:bg-color-info-secondary-subtle hover:text-color-brand" : "text-color-text-disabled bg-color-bg-2"]
        }, [_c("IconChevronLeft", {
          staticClass: "h-3 w-3 fill-current"
        })], 1)];
      }
    }, {
      key: "right-button",
      fn: function fn(slotScoped) {
        return [_c("div", {
          class: ["w-4 h-full flex items-center justify-center ml-1.5", slotScoped.show ? "bg-color-bg-2 text-color-text hover:bg-color-info-secondary-subtle hover:text-color-brand" : "text-color-text-disabled bg-color-bg-2"]
        }, [_c("IconChevronRight", {
          staticClass: "h-3 w-3 fill-current"
        })], 1)];
      }
    }, {
      key: "block",
      fn: function fn(_ref) {
        var _ref$slotScoped = _ref.slotScoped, node = _ref$slotScoped.node, index = _ref$slotScoped.index;
        return [_c("div", {
          class: _vm.m(_vm.gcls("steps-block"), _vm.gcls("steps-block-" + node[_vm.statusField]), {
            "bg-color-brand hover:bg-color-brand": index === _vm.active
          }, index === _vm.active && _vm.gcls("steps-block-" + node[_vm.statusField] + "-active"), {
            "min-w-[theme(spacing.28)] max-w-[theme(spacing.56)]": !_vm.flex
          }, _vm.size === "large" ? "h-12" : "h-8"),
          attrs: {
            "data-tag": "tiny-steps-block"
          },
          on: {
            "click": function click($event) {
              return _vm.$emit("click", index, node, $event);
            }
          }
        }, [_c("div", {
          class: _vm.gcls("steps-content"),
          attrs: {
            "data-tag": "tiny-steps-content"
          }
        }, [_vm._t("item", function() {
          return [_c("div", {
            class: _vm.m("w-4 h-4 flex flex-none items-center justify-center rounded-full mr-2 text-color-text-inverse", _vm.size === "large" ? "w-6 h-6 mr-3" : "w-4 h-4 mr-2", node[_vm.statusField] === "done" ? "bg-color-brand" : "bg-color-border", {
              " bg-color-brand group-hover:text-color-brand group-hover:bg-color-bg-1 ": node[_vm.statusField] === "doing"
            }, {
              " text-color-brand bg-color-bg-1": index === _vm.active && node[_vm.statusField] !== "disabled"
            }, {
              "text-color-text-inverse bg-color-error": node[_vm.statusField] === "error"
            }, {
              "text-color-error bg-color-bg-1": node[_vm.statusField] === "error" && index === _vm.active
            }),
            attrs: {
              "data-tag": "tiny-steps-icon"
            }
          }, [node[_vm.statusField] === "done" ? _c("icon-finish", {
            attrs: {
              "custom-class": ["fill-current", _vm.size === "large" ? "w-3.5 h-3.5" : "w-2.5 h-2.5"]
            }
          }) : node[_vm.statusField] === "error" ? _c("icon-warn", {
            attrs: {
              "custom-class": ["fill-current", _vm.size === "large" ? "w-3.5 h-3.5" : "w-2.5 h-2.5"]
            }
          }) : _c("span", [_vm._v(" " + _vm._s(index + 1) + " ")])], 1), _c("div", {
            staticClass: "flex-none",
            attrs: {
              "data-tag": "tiny-steps-prefixslot"
            }
          }, [_vm._t("prefix", function() {
            return [_c("div", {
              staticClass: "-mr-2"
            })];
          }, {
            "slotScope": {
              node,
              index
            }
          })], 2), _c("div", {
            class: _vm.m(_vm.gcls("steps-text"), _vm.gcls("steps-text-" + node[_vm.statusField]), {
              "text-color-text-inverse": index === _vm.active && node[_vm.statusField] !== "disabled"
            }),
            attrs: {
              "data-tag": "tiny-steps-text"
            }
          }, [_c("div", {
            staticClass: "truncate",
            attrs: {
              "data-tag": "tiny-steps-text-name"
            },
            on: {
              "mouseenter": function mouseenter($event) {
                return _vm.handleMouseenter($event, "top");
              },
              "mouseleave": function mouseleave($event) {
                return _vm.handleMouseleave($event, "top");
              }
            }
          }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]), _vm.size === "large" && node[_vm.descriptionField] ? _c("div", {
            class: _vm.m("truncate text-xs", {
              "text-color-text-secondary": index !== _vm.active && ["done", "doing"].includes(node[_vm.statusField])
            }, {
              "group-hover:text-white": index !== _vm.active && ["doing"].includes(node[_vm.statusField])
            }),
            attrs: {
              "data-tag": "tiny-steps-text-description"
            },
            on: {
              "mouseenter": function mouseenter($event) {
                return _vm.handleMouseenter($event, "bottom");
              },
              "mouseleave": function mouseleave($event) {
                return _vm.handleMouseleave($event, "bottom");
              }
            }
          }, [_vm._v(" " + _vm._s(node[_vm.descriptionField]) + " ")]) : _vm._e()])];
        }, {
          "slotScope": node,
          "index": index
        })], 2), _c("div", {
          class: ["h-full absolute left-0 border-t-transparent border-b-transparent border-color-bg-1", {
            "hidden": index === 0
          }],
          style: _vm.size === "large" ? "border-top-width: var(--tiny-spacing-6, 1.5rem);\n            border-bottom-width: var(--tiny-spacing-6, 1.5rem);\n            border-left-width: var(--tiny-spacing-2, 0.5625rem);" : "border-top-width: var(--tiny-spacing-4, 1rem);\n            border-bottom-width: var(--tiny-spacing-4, 1rem);\n            border-left-width: var(--tiny-spacing-1_5, 0.375rem);"
        }), _c("div", {
          class: ["h-full absolute right-0 border-l-transparent border-color-bg-1", {
            "hidden": index === _vm.data.length - 1
          }],
          style: _vm.size === "large" ? "border-top-width: var(--tiny-spacing-6, 1.5rem);\n            border-bottom-width: var(--tiny-spacing-6, 1.5rem);\n            border-left-width: var(--tiny-spacing-2, 0.5625rem);" : "border-top-width: var(--tiny-spacing-4, 1rem);\n            border-bottom-width: var(--tiny-spacing-4, 1rem);\n            border-left-width: var(--tiny-spacing-1_5, 0.375rem);"
        })])];
      }
    }, {
      key: "block-bottom",
      fn: function fn(_ref2) {
        var node = _ref2.node, index = _ref2.index;
        return [_vm._t("block-bottom", null, {
          "node": node,
          "index": index
        })];
      }
    }], null, true)
  }), _c("tiny-popover", {
    ref: "popover",
    staticClass: "tiny-steps-senior__popover",
    attrs: {
      "placement": _vm.state.popoverPlacement,
      "trigger": "manual",
      "content": _vm.state.popoverContent
    },
    model: {
      value: _vm.state.popoverVisible,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "popoverVisible", $$v);
      },
      expression: "state.popoverVisible"
    }
  })], 1);
};
var staticRenderFns = [];
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render, staticRenderFns, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var MobileFirstAdvancedTemplate = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var template = function template2(mode2, props2) {
  return props2.advanced ? MobileFirstAdvancedTemplate : MobileFirstTemplate;
};
var __vue2_script = defineComponent({
  name: $prefix + "Steps",
  props: _extends({}, $props, {
    nameField: {
      type: String,
      default: "name"
    },
    countField: {
      type: String,
      default: "count"
    },
    statusField: {
      type: String,
      default: "status"
    },
    data: [Object, Array],
    space: Number,
    active: {
      type: Number,
      default: -1
    },
    visibleNum: {
      type: Number,
      default: 3
    },
    descriptionField: {
      type: String,
      default: "description"
    },
    size: {
      type: String,
      default: "medium"
    },
    vertical: Boolean,
    advanced: Boolean,
    line: Boolean,
    duration: {
      type: Number,
      default: 300
    },
    noArrow: Boolean,
    flex: Boolean
  }),
  setup: function setup4(props2, context) {
    return $setup({
      props: props2,
      context,
      template
    });
  }
});
var __vue2_render, __vue2_staticRenderFns;
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, __vue2_render, __vue2_staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var mobileFirst = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { mobileFirst as default };
