import { defineComponent, props, setup, $prefix, $props, $setup } from '@opentinyvue/vue-common';
import { renderless, api } from '@opentinyvue/vue-renderless/steps/vue';
import { iconRefresh, iconYes, iconChevronLeft, iconChevronRight, iconFinish, iconWarn, IconFinish, IconWarn } from '@opentinyvue/vue-icon';
import Popover from '@opentinyvue/vue-popover';
import { renderless as renderless$1, api as api$1 } from '@opentinyvue/vue-renderless/steps/slide-bar';
import { AutoTip } from '@opentinyvue/vue-directive';
import '@opentinyvue/vue-theme/steps/index.css';

function normalizeComponent(scriptExports, render, staticRenderFns, functionalTemplate, injectStyles, scopeId, moduleIdentifier, shadowMode) {
  var options = typeof scriptExports === "function" ? scriptExports.options : scriptExports;
  if (render) {
    options.render = render;
    options.staticRenderFns = staticRenderFns;
    options._compiled = true;
  }
  var hook;
  if (injectStyles) {
    hook = injectStyles;
  }
  if (hook) {
    if (options.functional) {
      options._injectStyles = hook;
      var originalRender = options.render;
      options.render = function renderWithStyleInjection(h, context) {
        hook.call(context);
        return originalRender(h, context);
      };
    } else {
      var existing = options.beforeCreate;
      options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
    }
  }
  return {
    exports: scriptExports,
    options
  };
}

function _extends() {
  return _extends = Object.assign ? Object.assign.bind() : function(n) {
    for (var e = 1; e < arguments.length; e++) {
      var t = arguments[e];
      for (var r in t) ({}).hasOwnProperty.call(t, r) && (n[r] = t[r]);
    }
    return n;
  }, _extends.apply(null, arguments);
}
var __vue2_script$5 = defineComponent({
  emits: ["click"],
  components: {
    IconRefresh: iconRefresh(),
    IconYes: iconYes()
  },
  props: [].concat(props, ["vertical", "showNumber", "nameField", "statusField", "countField", "start", "data", "space", "active", "reverse"]),
  setup: function setup$1(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render$4 = function render$42() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-steps tiny-steps-standard"
  }, [_c("ul", {
    staticClass: "tiny-steps-advanced"
  }, _vm._l(_vm.data, function(node, index) {
    var _class;
    return _c("li", {
      key: index,
      class: (_class = {
        current: index === _vm.active
      }, _class[node[_vm.statusField]] = node[_vm.statusField], _class),
      style: {
        width: _vm.space ? _vm.state.computedSpace : 100 / _vm.data.length + "%"
      },
      on: {
        "click": function click($event) {
          return _vm.$emit("click", index, node);
        }
      }
    }, [_vm._t("item", function() {
      return [_c("div", {
        staticClass: "label",
        attrs: {
          "title": node[_vm.nameField]
        }
      }, [_c("span", [_vm._v(_vm._s(node[_vm.nameField]))])]), node[_vm.countField] ? _c("div", {
        staticClass: "count"
      }, [_vm._v(" " + _vm._s(node[_vm.countField]) + " ")]) : _vm._e(), node[_vm.statusField] ? _c("div", {
        class: ["dot", node[_vm.statusField]]
      }, [node[_vm.statusField] === "doing" ? _c("icon-refresh") : node[_vm.statusField] === "done" ? _c("icon-yes") : _vm._e()], 1) : _vm._e()];
    }, {
      "slotScope": node,
      "index": index
    })], 2);
  }), 0)]);
};
var staticRenderFns$4 = [];
var __cssModules$5 = {};
var __component__$5 = /* @__PURE__ */ normalizeComponent(__vue2_script$5, render$4, staticRenderFns$4, false, __vue2_injectStyles$5);
function __vue2_injectStyles$5(context) {
  for (var o in __cssModules$5) {
    this[o] = __cssModules$5[o];
  }
}
var PcStandardTemplate = /* @__PURE__ */ function() {
  return __component__$5.exports;
}();
var __vue2_script$4 = defineComponent({
  emits: ["click"],
  components: {
    IconChevronLeft: iconChevronLeft(),
    IconChevronRight: iconChevronRight()
  },
  props: _extends({}, $props, {
    data: Array,
    duration: {
      type: Number,
      default: 300
    },
    delay: {
      type: Number,
      default: 5
    },
    noArrow: Boolean,
    flex: Boolean
  }),
  setup: function setup2(props2, context) {
    return setup({
      props: props2,
      context,
      renderless: renderless$1,
      api: api$1
    });
  }
});
var render$3 = function render$32() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "tiny-steps-slide-bar",
    attrs: {
      "data-tag": "tiny-steps-slide-bar"
    }
  }, [_c("div", {
    ref: "leftButton",
    class: ["more-button left", {
      "display-flex": _vm.slideBarState.canLeftScroll || _vm.slideBarState.canRightScroll
    }],
    on: {
      "click": _vm.leftSlideHandler
    }
  }, [_vm._t("left-button", function() {
    return [_c("div", {
      staticClass: "content"
    }, [_c("IconChevronLeft", {
      staticClass: "icon"
    })], 1)];
  }, {
    "show": _vm.slideBarState.canLeftScroll,
    "index": _vm.slideBarState.boundingIndex.left
  })], 2), _c("div", {
    ref: "slideMain",
    staticClass: "slide-main"
  }, [_c("div", _vm._l(_vm.data, function(node, index) {
    return _c("div", {
      key: index,
      ref: "block" + index,
      refInFor: true,
      style: {
        width: _vm.flex ? 100 / _vm.data.length + "%" : null
      }
    }, [_vm._t("block", function() {
      return [_vm._v(_vm._s(index))];
    }, {
      "slotScoped": {
        node,
        index,
        show: index > _vm.slideBarState.boundingIndex.left && (_vm.slideBarState.boundingIndex.right === -1 || index < _vm.slideBarState.boundingIndex.right)
      }
    }), _vm._t("block-bottom", null, {
      "node": node,
      "index": index
    })], 2);
  }), 0)]), _c("div", {
    ref: "rightButton",
    class: ["more-button right", {
      "display-flex": _vm.slideBarState.canLeftScroll || _vm.slideBarState.canRightScroll
    }],
    on: {
      "click": _vm.rightSlideHandler
    }
  }, [_vm._t("right-button", function() {
    return [_c("div", {
      staticClass: "content"
    }, [_c("IconChevronRight", {
      staticClass: "icon"
    })], 1)];
  }, {
    "show": _vm.slideBarState.canRightScroll,
    "index": _vm.slideBarState.boundingIndex.right
  })], 2)]);
};
var staticRenderFns$3 = [];
var __cssModules$4 = {};
var __component__$4 = /* @__PURE__ */ normalizeComponent(__vue2_script$4, render$3, staticRenderFns$3, false, __vue2_injectStyles$4);
function __vue2_injectStyles$4(context) {
  for (var o in __cssModules$4) {
    this[o] = __cssModules$4[o];
  }
}
var SlideBar = /* @__PURE__ */ function() {
  return __component__$4.exports;
}();
var __vue2_script$3 = defineComponent({
  emits: ["click"],
  components: {
    TinyPopover: Popover,
    SlideBar,
    IconFinish: iconFinish(),
    IconWarn: iconWarn(),
    IconChevronLeft: iconChevronLeft(),
    IconChevronRight: iconChevronRight()
  },
  props: [].concat(props, ["vertical", "nameField", "statusField", "descriptionField", "data", "active", "visibleNum", "duration", "noArrow", "flex", "size"]),
  setup: function setup3(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render$2 = function render$22() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: ["tiny-steps tiny-steps-senior", _vm.size],
    attrs: {
      "data-tag": "tiny-steps-senior"
    }
  }, [_c("SlideBar", {
    ref: "slideBar",
    attrs: {
      "data": _vm.data,
      "duration": _vm.duration,
      "no-arrow": _vm.noArrow,
      "flex": _vm.flex
    },
    scopedSlots: _vm._u([{
      key: "left-button",
      fn: function fn(slotScoped) {
        return [_c("div", {
          class: ["more-button-con left", {
            "bar-visible": slotScoped.show
          }]
        }, [_c("IconChevronLeft", {
          staticClass: "icon"
        })], 1)];
      }
    }, {
      key: "right-button",
      fn: function fn(slotScoped) {
        return [_c("div", {
          class: ["more-button-con right", {
            "bar-visible": slotScoped.show
          }]
        }, [_c("IconChevronRight", {
          staticClass: "icon"
        })], 1)];
      }
    }, {
      key: "block",
      fn: function fn(_ref) {
        var _ref$slotScoped = _ref.slotScoped, node = _ref$slotScoped.node, index = _ref$slotScoped.index;
        return [_c("div", {
          class: ["tiny-steps-block", {
            "not-flex": !_vm.flex
          }, node[_vm.statusField] === "error" ? "fault" : node[_vm.statusField], {
            "active": index === _vm.active
          }],
          on: {
            "click": function click($event) {
              return _vm.$emit("click", index, node, $event);
            }
          }
        }, [_c("div", {
          staticClass: "tiny-steps-content"
        }, [_vm._t("item", function() {
          return [_c("div", {
            class: ["tiny-steps-icon", node[_vm.statusField] === "error" ? "fault" : node[_vm.statusField], {
              "active": index === _vm.active
            }]
          }, [node[_vm.statusField] === "done" ? _c("icon-finish", {
            staticClass: "icon icon-finish"
          }) : node[_vm.statusField] === "error" ? _c("icon-warn", {
            staticClass: "icon icon-warn"
          }) : _c("span", [_vm._v(" " + _vm._s(index + 1) + " ")])], 1), _c("div", {
            staticClass: "tiny-steps-prefixslot"
          }, [_vm._t("prefix", function() {
            return [_c("div", {
              staticClass: "prefix"
            })];
          }, {
            "slotScope": {
              node,
              index
            }
          })], 2), _c("div", {
            class: ["tiny-steps-text", node[_vm.statusField] === "error" ? "fault" : node[_vm.statusField], {
              "active": index === _vm.active
            }]
          }, [_c("div", {
            staticClass: "tiny-steps-text-name",
            on: {
              "mouseenter": function mouseenter($event) {
                return _vm.handleMouseenter($event, "top");
              },
              "mouseleave": function mouseleave($event) {
                return _vm.handleMouseleave($event, "top");
              }
            }
          }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]), _vm.size === "large" && node[_vm.descriptionField] ? _c("div", {
            staticClass: "tiny-steps-text-description",
            on: {
              "mouseenter": function mouseenter($event) {
                return _vm.handleMouseenter($event, "bottom");
              },
              "mouseleave": function mouseleave($event) {
                return _vm.handleMouseleave($event, "bottom");
              }
            }
          }, [_vm._v(" " + _vm._s(node[_vm.descriptionField]) + " ")]) : _vm._e()])];
        }, {
          "slotScope": node,
          "index": index
        })], 2), _c("div", {
          class: ["left-arrow arrow", {
            "hide": index === 0
          }]
        }), _c("div", {
          class: ["right-arrow arrow", {
            "hide": index === _vm.data.length - 1
          }]
        })])];
      }
    }, {
      key: "block-bottom",
      fn: function fn(_ref2) {
        var node = _ref2.node, index = _ref2.index;
        return [_vm._t("block-bottom", null, {
          "node": node,
          "index": index
        })];
      }
    }], null, true)
  }), _c("tiny-popover", {
    ref: "popover",
    staticClass: "tiny-steps-senior__popover",
    attrs: {
      "placement": _vm.state.popoverPlacement,
      "trigger": "manual",
      "content": _vm.state.popoverContent
    },
    model: {
      value: _vm.state.popoverVisible,
      callback: function callback($$v) {
        _vm.$set(_vm.state, "popoverVisible", $$v);
      },
      expression: "state.popoverVisible"
    }
  })], 1);
};
var staticRenderFns$2 = [];
var __cssModules$3 = {};
var __component__$3 = /* @__PURE__ */ normalizeComponent(__vue2_script$3, render$2, staticRenderFns$2, false, __vue2_injectStyles$3);
function __vue2_injectStyles$3(context) {
  for (var o in __cssModules$3) {
    this[o] = __cssModules$3[o];
  }
}
var PcAdvancedTemplate = /* @__PURE__ */ function() {
  return __component__$3.exports;
}();
var __vue2_script$2 = defineComponent({
  components: {
    IconFinish: IconFinish(),
    IconWarn: IconWarn()
  },
  directives: {
    AutoTip
  },
  // 新规范
  emits: ["click"],
  props: [].concat(props, ["vertical", "nameField", "statusField", "data", "active", "visibleNum", "descriptionField", "size"]),
  setup: function setup4(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render$1 = function render$12() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: ["tiny-steps tiny-steps-line", _vm.size, {
      vertical: _vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps"
    }
  }, [_c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.startIndex !== 0,
      expression: "state.startIndex !== 0"
    }],
    class: ["tiny-steps-left", {
      "vertical": _vm.vertical
    }],
    on: {
      "click": function click($event) {
        _vm.state.startIndex--;
      }
    }
  }, [_c("div", {
    staticClass: "tiny-steps-main"
  }, [_c("div", {
    class: ["line left-line", {
      "not-vertical": !_vm.vertical
    }]
  }), _c("div", {
    staticClass: "tiny-steps-icon"
  }, [_c("span", {
    staticClass: "item-number"
  }, [_vm._v(" " + _vm._s(_vm.size === "mini" ? "" : _vm.state.startIndex) + " ")]), _vm.state.startIndex - 1 > 0 ? _vm._l(_vm.state.startIndex - 1, function(item, index) {
    return _c("div", {
      key: index,
      staticClass: "item-circle",
      style: {
        right: (_vm.state.startIndex - 1 - index) * 4 + "px"
      }
    });
  }) : _vm._e()], 2), _c("div", {
    class: ["line right-line", {
      "not-vertical": !_vm.vertical
    }, {
      "line-brand": _vm.data[_vm.state.startIndex - 1] && _vm.data[_vm.state.startIndex - 1].status === "done"
    }]
  })])]), _vm._l(_vm.data, function(node, index) {
    return _c("div", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: _vm.isVisibleHandler(index) === "visible",
        expression: "isVisibleHandler(index) === 'visible'"
      }],
      key: index,
      class: ["tiny-steps-block", _vm.size, node[_vm.statusField] === "error" ? "fault" : node[_vm.statusField], {
        "active": index === _vm.active
      }, {
        "not-vertical": !_vm.vertical
      }, {
        "flex-non": index === _vm.data.length - 1 && !_vm.vertical
      }, {
        "block-mini": _vm.data.length > 3
      }],
      on: {
        "click": function click($event) {
          return _vm.$emit("click", index, node, $event);
        }
      }
    }, [_c("div", {
      staticClass: "tiny-steps-main"
    }, [_c("div", {
      class: ["line left-line", {
        "acetate": index === 0 && _vm.state.startIndex === 0
      }, {
        "not-vertical": !_vm.vertical
      }]
    }), _c("div", {
      class: ["tiny-steps-icon", node[_vm.statusField] === "error" ? "fault" : node[_vm.statusField], {
        "active": index === _vm.active
      }]
    }, [_vm.size !== "mini" ? [node[_vm.statusField] === "done" ? [_c("icon-finish", {
      class: ["icon icon-finish", {
        "active": index === _vm.active
      }]
    })] : node[_vm.statusField] === "error" ? [_c("icon-warn", {
      class: ["icon icon-warn", {
        "active": index === _vm.active
      }]
    })] : [_vm._v(" " + _vm._s(index + 1) + " ")]] : _vm._e()], 2), !_vm.vertical ? _c("div", {
      directives: [{
        name: "auto-tip",
        rawName: "v-auto-tip",
        value: {
          placement: "bottom"
        },
        expression: "{ placement: 'bottom' }"
      }],
      staticClass: "title"
    }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]) : _vm._e(), _c("div", {
      class: ["line right-line", {
        "hide": !_vm.vertical && index === _vm.data.length - 1
      }, {
        "acetate": index === _vm.data.length - 1
      }, {
        "not-vertical": !_vm.vertical
      }]
    })]), _vm._t("item", function() {
      return [_c("div", {
        directives: [{
          name: "auto-tip",
          rawName: "v-auto-tip",
          value: {
            placement: "bottom"
          },
          expression: "{ placement: 'bottom' }"
        }],
        class: ["title-vertical", {
          "not-vertical": !_vm.vertical
        }]
      }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]), node[_vm.descriptionField] ? _c("div", {
        directives: [{
          name: "auto-tip",
          rawName: "v-auto-tip",
          value: {
            placement: "bottom"
          },
          expression: "{ placement: 'bottom' }"
        }],
        class: ["description", node[_vm.statusField] === "error" ? "fault" : node[_vm.statusField], {
          "not-vertical": !_vm.vertical
        }]
      }, [_vm._v(" " + _vm._s(node[_vm.descriptionField]) + " ")]) : _vm._e(), _vm.slots.itemFooter ? _c("div", {
        staticClass: "line-footer"
      }, [_vm._t("itemFooter", null, {
        "slotScope": node,
        "index": index
      })], 2) : _vm._e()];
    }, {
      "slotScope": node,
      "index": index
    })], 2);
  }), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.state.startIndex + _vm.visibleNum < _vm.data.length,
      expression: "state.startIndex + visibleNum < data.length"
    }],
    class: ["tiny-steps-right", {
      "not-vertical": !_vm.vertical
    }],
    on: {
      "click": function click($event) {
        _vm.state.startIndex++;
      }
    }
  }, [_c("div", {
    staticClass: "tiny-steps-main"
  }, [_c("div", {
    class: ["line left-line", {
      "not-vertical": !_vm.vertical
    }, {
      "line-brand": _vm.data[_vm.state.endIndex] && ["done", "doing"].includes(_vm.data[_vm.state.endIndex].status)
    }]
  }), _c("div", {
    staticClass: "tiny-steps-icon"
  }, [_c("span", {
    staticClass: "item-number"
  }, [_vm._v(" " + _vm._s(_vm.size === "mini" ? "" : _vm.state.endIndex + 1) + " ")]), _vm.state.rightNodePositions.length > 0 ? _vm._l(_vm.state.rightNodePositions, function(item, index) {
    return _c("div", {
      key: index,
      staticClass: "item-circle",
      style: item
    });
  }) : _vm._e()], 2), _c("div", {
    class: ["line right-line", {
      "not-vertical": !_vm.vertical
    }]
  })])])], 2);
};
var staticRenderFns$1 = [];
var __cssModules$2 = {};
var __component__$2 = /* @__PURE__ */ normalizeComponent(__vue2_script$2, render$1, staticRenderFns$1, false, __vue2_injectStyles$2);
function __vue2_injectStyles$2(context) {
  for (var o in __cssModules$2) {
    this[o] = __cssModules$2[o];
  }
}
var PcLineTemplate = /* @__PURE__ */ function() {
  return __component__$2.exports;
}();
var __vue2_script$1 = defineComponent({
  emits: ["click"],
  props: [].concat(props, ["vertical", "nameField", "statusField", "data", "active", "descriptionField", "size"]),
  setup: function setup5(props2, context) {
    return setup({
      props: props2,
      context,
      renderless,
      api
    });
  }
});
var render = function render2() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    class: ["tiny-steps tiny-steps-dot", _vm.size, {
      vertical: _vm.vertical
    }],
    attrs: {
      "data-tag": "tiny-steps"
    }
  }, _vm._l(_vm.data, function(node, index) {
    return _c("div", {
      key: index,
      class: ["tiny-steps-block", _vm.size, node[_vm.statusField] === "error" ? "fault" : node[_vm.statusField], {
        "active": index === _vm.active
      }, {
        "not-vertical": !_vm.vertical
      }, {
        "flex-non": index === _vm.data.length - 1 && !_vm.vertical
      }],
      on: {
        "click": function click($event) {
          return _vm.$emit("click", index, node, $event);
        }
      }
    }, [_c("div", {
      class: ["block-left", {
        "active": index === _vm.active
      }]
    }, [_c("div", {
      class: ["left-dot", {
        "not-vertical": !_vm.vertical
      }]
    }), _c("div", {
      class: ["left-line", {
        "hide": !_vm.vertical && index === _vm.data.length - 1
      }, {
        "acetate": index === _vm.data.length - 1
      }, {
        "not-vertical": !_vm.vertical
      }]
    })]), _vm._t("item", function() {
      return [_c("div", {
        staticClass: "block-right"
      }, [_c("div", {
        class: ["title-vertical", {
          "not-vertical": !_vm.vertical
        }],
        attrs: {
          "title": node[_vm.nameField]
        }
      }, [_vm._v(" " + _vm._s(node[_vm.nameField]) + " ")]), node[_vm.descriptionField] ? _c("div", {
        class: ["description", {
          "not-vertical": !_vm.vertical
        }]
      }, [_vm._v(" " + _vm._s(node[_vm.descriptionField]) + " ")]) : _vm._e()])];
    }, {
      "slotScope": node,
      "index": index
    })], 2);
  }), 0);
};
var staticRenderFns = [];
var __cssModules$1 = {};
var __component__$1 = /* @__PURE__ */ normalizeComponent(__vue2_script$1, render, staticRenderFns, false, __vue2_injectStyles$1);
function __vue2_injectStyles$1(context) {
  for (var o in __cssModules$1) {
    this[o] = __cssModules$1[o];
  }
}
var PcDotTemplate = /* @__PURE__ */ function() {
  return __component__$1.exports;
}();
var template = function template2(mode, props2) {
  if (props2.advanced) {
    return PcAdvancedTemplate;
  } else if (props2.line) {
    return PcLineTemplate;
  } else if (props2.dot) {
    return PcDotTemplate;
  } else {
    return PcStandardTemplate;
  }
};
var __vue2_script = defineComponent({
  name: $prefix + "Steps",
  props: _extends({}, $props, {
    nameField: {
      type: String,
      default: "name"
    },
    countField: {
      type: String,
      default: "count"
    },
    statusField: {
      type: String,
      default: "status"
    },
    data: [Object, Array],
    space: [String, Number],
    active: {
      type: Number,
      default: -1
    },
    visibleNum: {
      type: Number,
      default: 5
    },
    descriptionField: {
      type: String,
      default: "description"
    },
    vertical: Boolean,
    advanced: Boolean,
    line: Boolean,
    dot: Boolean,
    duration: {
      type: Number,
      default: 300
    },
    size: {
      type: String,
      default: "medium"
    },
    noArrow: Boolean,
    flex: Boolean
  }),
  setup: function setup6(props2, context) {
    return $setup({
      props: props2,
      context,
      template
    });
  }
});
var __vue2_render, __vue2_staticRenderFns;
var __cssModules = {};
var __component__ = /* @__PURE__ */ normalizeComponent(__vue2_script, __vue2_render, __vue2_staticRenderFns, false, __vue2_injectStyles);
function __vue2_injectStyles(context) {
  for (var o in __cssModules) {
    this[o] = __cssModules[o];
  }
}
var pc = /* @__PURE__ */ function() {
  return __component__.exports;
}();

export { pc as default };
